#include "msp430g2553.h"

#include "delay.h"

const unsigned int spwm[] = {

250, 327, 396, 452, 487, 499, 487, 452, 396, 327,

250, 172, 103, 47, 12, 0, 12, 47, 103, 172,

};

unsigned int n=0;

/*

*

*/

void TimerA_Init()

{

P1DIR |= BIT2;

P1SEL |= BIT2;                            // p1.2

TACCR0 = 500;                              // Init TACCR0 w/ sample prd=CCR0+1

TACCR1= spwm[n];

TACCTL1 = OUTMOD_7;                            // Set/reset

TACCTL0 = CCIE;

TACTL = TACLR + MC_1 + TASSEL_2 +ID_3;                // clear TAR, up mode*/

}

void ini_sys(void)

{

   WDTCTL=WDTPW+WDTHOLD;  //STOP W D T

   if (CALBC1_8MHZ ==0xFF || CALDCO_8MHZ == 0xFF)

   	{

   	 while(1);                               // If calibration constants erased

   	 // do not load, trap CPU!!

   	}

   	 //1Mhz  ~1008000

   	BCSCTL1 = CALBC1_16MHZ;                    // Set range

   	DCOCTL = CALDCO_16MHZ;                     // Set DCO step + modulation */

   	delay_ms(10);

}

/*

* main()

*/

void main()

{

   ini_sys();

   TimerA_Init();

   _EINT();

 //_BIS_SR(LPM0_bits + GIE);

   while(1);

}

/*

*	T0_A0 interrupt service

*/

#pragma vector=TIMER0_A0_VECTOR

__interrupt void Timer0_A0(void)

{

//һȡ180㣬2

TACCR1 = spwm[n++];

if(n == 20)
{

n=0;

}

}